<?php
/*
Plugin Name:  Display Name2
Plugin URI: http://bbpress.org/plugins/
Description: Displays the login name for members, but uses the "display_name" as set by WordPress or in BB for a bbPress moderator's name instead of the login name. 
Author: Thierryyyyyyy B
Author URI: http://www.2diabolos.com/blog
Version: 1.0

License: http://creativecommons.org/licenses/GPL/2.0/
*/

function bb_use_display_name( $name, $id ) {
	$user = bb_get_user( bb_get_user_id( $id ) );
	if ( $user->capabilities['keymaster']==1 || $user->capabilities['moderator']==1 ) return $user->display_name;
	return $user->user_login; //Mod
}

add_filter( 'topic_last_poster', 'bb_use_display_name', 1, 2 );
add_filter( 'topic_author', 'bb_use_display_name', 1, 2 );
add_filter( 'get_post_author', 'bb_use_display_name', 1, 2 );
add_filter( 'get_user_name', 'bb_use_display_name', 1, 2 );


function bb_topic_poster_display_name ($topic_id, $args) {
	global $bbdb;
	if ( ! ( isset($args['topic_id']) && false !== $args['topic_id'] ) ) {
		$displayname = bb_use_display_name( "nullllll", bb_get_current_user_info( 'id' )) ;
		if ($displayname != "nullllll") // pour une raison incomprise, le topic_last_poster_name = '$displayname' n'est pas pris en compte ... mais a ne se voit pas sur la page au finale.
			$bbdb->query( "UPDATE $bbdb->topics SET topic_poster_name = '$displayname', topic_last_poster_name = '$displayname' WHERE topic_id = $topic_id");
	}
}
add_action('bb_insert_topic', 'bb_topic_poster_display_name',150,2 );

function disable_display_name_keys($keys){
	$user = bb_get_user( bb_get_user_id( $id ) );
	if ( $user->capabilities['keymaster']==1 || $user->capabilities['moderator']==1 ) return $keys;
	else unset($keys['display_name']);
	return $keys;
}
add_filter('get_profile_info_keys', 'disable_display_name_keys',9);
?>
